package de.intevation.flys.importer;

import de.intevation.flys.model.HYKEntry;
import de.intevation.flys.model.HYK;

import java.util.Date;
import java.util.List;
import java.util.ArrayList;

import java.math.BigDecimal;

import org.hibernate.Session;
import org.hibernate.Query;

public class ImportHYKEntry
{
    protected ImportHYK  hyk;
    protected BigDecimal km;
    protected Date       measure;

    protected List<ImportHYKFormation> formations;

    protected HYKEntry peer;

    public ImportHYKEntry() {
        formations = new ArrayList<ImportHYKFormation>();
    }

    public ImportHYKEntry(
        ImportHYK  hyk,
        BigDecimal km,
        Date       measure
    ) {
        this.hyk     = hyk;
        this.km      = km;
        this.measure = measure;
    }

    public ImportHYK getHYK() {
        return hyk;
    }

    public void setHYK(ImportHYK hyk) {
        this.hyk = hyk;
    }

    public void addFormation(ImportHYKFormation formation) {
        int numFormation = formations.size();
        formations.add(formation);
        formation.setFormationNum(numFormation);
        formation.setEntry(this);
    }

    public HYKEntry getPeer() {
        if (peer == null) {
            HYK h = hyk.getPeer();
            Session session = ImporterSession.getInstance()
                .getDatabaseSession();
            Query query = session.createQuery(
                "from HYKEntry where hyk=:hyk " +
                "and km=:km and measure=:measure");
            query.setParameter("hyk", h);
            query.setParameter("km", km);
            query.setParameter("measure", measure);
            List<HYKEntry> entries = query.list();
            if (entries.isEmpty()) {
                peer = new HYKEntry(h, km, measure);
                session.save(peer);
            }
            else {
                peer = entries.get(0);
            }
        }
        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
